﻿using Dicom.Network;
using NLog;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reactive.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using DicomClient = Dicom.Network.Client.DicomClient;
using System.Reactive.Threading.Tasks;
using System.CodeDom;

namespace C_UI
{

    public static class SCU_Store
    {

        static Logger logger = LogManager.GetCurrentClassLogger();
        public static async Task StoreFile(string _storeServerHost, int _storeServerPort, IObservable<string> dicomFiles
            , string _aet, string _storeServerAET)
        {
            var client = new DicomClient(_storeServerHost, _storeServerPort, false, _storeServerAET, _aet);
            client.NegotiateAsyncOps();
            
            dicomFiles.Subscribe(
            async onNext =>
            {                
                
                var request = new DicomCStoreRequest(onNext);
                request.OnResponseReceived += (req, response) => logger.Info($"{response.Status}-{onNext}" );
                await client.AddRequestAsync(request);
                await client.SendAsync();
            },
            onError =>
            {
                logger.Error(onError.Message);
            }
            );

        }
    }
}
